//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

function Tick()
{
    try { TF_TEAM.RED; } catch(e) { return; }

    if (IsValidRound())
        FireListeners("tick_only_valid", 0.1);
    FireListeners("tick_always", 0.1);

    return 0.1;
}

function OnScriptHook_OnTakeDamage(params)
{
    if (params.const_entity == worldSpawn) //wall climb off of the static world
    {
        if (params.damage_type & 128)  // Constants.FDmgType.DMG_CLUB - constants are slower than plain numbers
            MeleeWallClimb_Hit(params);
        return;
    }
    if (params.damage_type & 128) // Wall climb off of the rest of the world. worldspawn handled separately for performance reasons
    {
        if (MeleeWallClimb_Check(params))
        {
            MeleeWallClimb_Hit(params);
            return;
        }
    }
    if (IsNotValidRound() || IsNotValidPlayerOrBuilding(params.const_entity))
        return;
    FireListeners("damage_hook", params);
}

function OnGameEvent_player_hurt(params)
{
    if (IsNotValidRound())
        return;
    local victim;
    if ((victim = GetPlayerFromParams(params)) == null)
        return;
    local attacker;
    if ((attacker = GetPlayerFromParams(params, "attacker")) == null)
        return;
    FireListeners("player_hurt", [attacker, victim, params]);
}

function OnGameEvent_player_team(params)
{
    if (IsNotValidRound())
        return;
    if (!("userid" in params))
        return null;
    local player = GetPlayerFromUserID(params.userid);
    if (player == null || !player.IsValid() || !player.IsPlayer())
        return;
    FireListeners("team_change", params);
}

function OnGameEvent_player_changeclass(params)
{
    if (IsNotValidRound())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("class_change", params);
}

function OnGameEvent_player_spawn(params)
{
    if (IsNotValidRound())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("spawn", player);
}

function OnGameEvent_player_death(params)
{
    if (params.death_flags & TF_DEATHFLAG.DEAD_RINGER || IsNotValidRound())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("death", params);
}

function OnGameEvent_player_disconnect(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    FireListeners("disconnect", params);
}

function OnGameEvent_post_inventory_application(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null || player.GetBotType() == Constants.EBotType.TF_BOT_TYPE)
        return;

    //player.GTFW_Cleanup();

    FireListeners("post_inventory", player);
}

function OnGameEvent_player_say(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]")
        return;

    if (params.text == "!restart")
        EndRound(TF_TEAM.NONE);

    if (params.text.find("!setn")==0)
        SetPersistentVar("zombies_n", params.text.slice(6).tointeger());

    //todo hardcoded
}

__CollectGameEventCallbacks(this);
__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);