//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

isRoundSetup <- true
isRoundOver <- false;
starterClass <- {}
isFeedbackRound <- false;
survivors <- [];

function unsort(first, second)
{
    if (first == second)
        return 0;
    return RandomInt(0, 1) == 0 ? -1 : 1;
}

function StartNewRound(void)
{
    if (isFeedbackRound || IsInWaitingForPlayers() || GetTotalPlayerCount() < 2)
        return;

    local players = GetAllValidPlayers();
    players.sort(unsort);
    players.sort(unsort);
    //players.insert(0,PlayerInstanceFromIndex(1))
    local humanQuota;
    if (infection)
        humanQuota = players.len() - (2 + players.len() / GetPersistentVar("zombies_n", 10));
    else
        humanQuota = clampFloor(1, (players.len() - 1) / 3 + 1);
    for(local i = 0; i < humanQuota; i++)
        //if (players[i].IsFakeClient()) //todo
            survivors.push(players[i]);

    local forceRespawn = Entities.FindByClassname(null, "game_forcerespawn");
    EntFireByHandle(forceRespawn, "ForceRespawn", "", 0, null, null);
}
AddListener("round_start", StartNewRound, 0);

function FinishRoundSetup()
{
    isRoundSetup = false;
}

function EndRound(winner)
{
    if (isRoundOver)
        return;

    local roundWin = Entities.FindByClassname(null, "game_round_win");
    if (roundWin == null)
    {
        roundWin = SpawnEntityFromTable("game_round_win",
        {
            win_reason = "0",
            force_map_reset = "1", //not having
            TeamNum = "0",         //these 3 lines
            switch_teams = "0"     //causes the crash when trying to fire game_round_win
        });
    }
    EntFireByHandle(roundWin, "SetTeam", "" + winner, 0, null, null);
    EntFireByHandle(roundWin, "RoundWin", "", 0, null, null);

    isRoundOver = true;
}