//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

hitStreak <- {};
ignoreWallClimb <- [
    "player",
    "tf_bot",
    "obj_sentrygun",
    "obj_dispenser",
    "obj_teleporter"
]

function MeleeWallClimb_Hit(params)
{
    local player = params.attacker;
    if (!IsValidPlayer(player) || IsSurvivor(player))
        return;
    MeleeClimb_Perform(player);
}

function MeleeWallClimb_Check(params)
{
    return ignoreWallClimb.find(params.const_entity.GetClassname()) == null;
}

function MeleeWallClimb_Tick(void)
{
    foreach (player in GetAliveZombies())
        if ((player.GetFlags() & Constants.FPlayer.FL_ONGROUND))
            hitStreak[player] <- 0;
}
AddListener("tick_always", MeleeWallClimb_Tick, 0);

function MeleeClimb_Perform(player)
{
    local hits = (player in hitStreak ? hitStreak[player] : 0) + 1;
    local launchVelocity = hits == 1 ? 600 : hits == 2 ? 450 : 400;
    hitStreak[player] <- hits;

    SetPropEntity(player, "m_hGroundEntity", null);
    player.RemoveFlag(Constants.FPlayer.FL_ONGROUND);

    local newVelocity = player.GetAbsVelocity();
    if (hits == 2)
    {
        newVelocity.x /= 2;
        newVelocity.y /= 2;
    }
    newVelocity.z = launchVelocity > 430 ? launchVelocity : launchVelocity + newVelocity.z;
    player.SetAbsVelocity(newVelocity);
}