//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript(vscript_dir+"/survivors/all_class/last_mann_standing.nut");
IncludeScript(vscript_dir+"/survivors/all_class/zombie_gas_is_napalm.nut");
IncludeScript(vscript_dir+"/survivors/all_class/melee_crits.nut");
IncludeScript(vscript_dir+"/survivors/all_class/melee_wall_climb.nut");

IncludeScript(vscript_dir+"/survivors/single_class/engineer_sentry.nut");
IncludeScript(vscript_dir+"/survivors/single_class/heavy_minigun.nut");
IncludeScript(vscript_dir+"/survivors/single_class/heavy_natasha_nerf.nut");
IncludeScript(vscript_dir+"/survivors/single_class/medic_uber_rate.nut");

function TrySpawnAsSurvivor(player)
{
    if (!IsSurvivor(player) || survivors.len() == 0)
        return;

    if (player.GetTeam() != GetSurvivorsTeam())
    {
        player.SwitchTeam(GetSurvivorsTeam());
        player.ForceRegenerateAndRespawn();
    }

    player.SetCustomModelWithClassAnimations("")
    SetPropInt(player, "m_bForcedSkin", 0);
}
AddListener("spawn", TrySpawnAsSurvivor, 0);

function ZombieClassChange(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    if (!IsZombie(player))
        return;
    local desiredClass = params["class"];

    if (player.GetHealth() >= player.GetMaxHealth())
    {
        player.SetPlayerClass(desiredClass);
        player.ForceRegenerateAndRespawn();
    }
}
AddListener("class_change", ZombieClassChange, 0);

function TeamChangeHandler(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    if (IsZombie(player) && params.team != GetZombiesTeam())
        RunWithDelay("SwitchPlayerTeam(activator, GetZombiesTeam())", player, 0);
    if (IsSurvivor(player) && params.team != GetSurvivorsTeam())
        RunWithDelay("SwitchPlayerTeam(activator, GetSurvivorsTeam())", player, 0);
}
AddListener("team_change", TeamChangeHandler, 0);

function SurvivorDeath(params)
{
    if (!infection || IsRoundSetup())
        return;
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    AssignToZombies(player);
}
AddListener("death", SurvivorDeath, 0);
AddListener("disconnect", SurvivorDeath, 0);

function AssignToZombies(player)
{
    local index = survivors.find(player);
    if (index != null)
        survivors.remove(index);
    player.SwitchTeam(GetZombiesTeam());
    if (survivors.len() == 0)
        EndRound(GetZombiesTeam());
}

function RoundEndCheck(interval)
{
    if (!infection || IsInWaitingForPlayers() || GetTotalPlayerCount() < 2)
        return;
    if (GetSurvivorCount() <= 0)
        EndRound(GetZombiesTeam());
}
AddListener("tick_always", RoundEndCheck, 1);