//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

::clampCeiling <- function(valueA, valueB)
{
    if (valueA < valueB)
        return valueA;
    return valueB;
}

::clampFloor <- function(valueA, valueB)
{
    if (valueA > valueB)
        return valueA;
    return valueB;
}

::clamp <- function(value, min, max)
{
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}

function StartFeedbackRound()
{
    isFeedbackRound = true;
}

function IsNotValidRound()
{
    return isFeedbackRound || IsInWaitingForPlayers();
}

function IsValidRound()
{
    return !isFeedbackRound && !IsInWaitingForPlayers();
}

function IsRoundSetup()
{
    return isRoundSetup;
}

function IsRoundOver()
{
    return isRoundOver;
}

::SetPersistentVar <- function(name, value)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    persistentVars[name] <- value;
}

::GetPersistentVar <- function(name, defValue = null)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    return name in persistentVars ? persistentVars[name] : defValue;
}

::RunWithDelay <- function(func, activator, delay)
{
    EntFireByHandle(vscript_entity, "RunScriptCode", func, delay, activator, activator);
}