//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

class ZombieChange extends CharacterChange
{
    function CheckTeam()
    {
        return vscript.IsZombie(player);
    }
}

IncludeScript(vscript_dir+"/zombies/all_class/better_zombie_hitreg.nut");

IncludeScript(vscript_dir+"/zombies/single_class/soldier.nut");
IncludeScript(vscript_dir+"/zombies/single_class/pyro.nut");
IncludeScript(vscript_dir+"/zombies/single_class/engineer.nut");
IncludeScript(vscript_dir+"/zombies/single_class/medic.nut");

ZOMBIE_MODELS <- [
    "models/player/items/scout/scout_zombie.mdl",
    "models/player/items/scout/scout_zombie.mdl",
    "models/player/items/sniper/sniper_zombie.mdl",
    "models/player/items/soldier/soldier_zombie.mdl",
    "models/player/items/demo/demo_zombie.mdl",
    "models/player/items/medic/medic_zombie.mdl",
    "models/player/items/heavy/heavy_zombie.mdl",
    "models/player/items/pyro/pyro_zombie.mdl",
    "models/player/items/spy/spy_zombie.mdl",
    "models/player/items/engineer/engineer_zombie.mdl"
]

crumpkin_model <- GetModelIndex("models/props_halloween/pumpkin_loot.mdl");

function TrySpawnAsZombie(player)
{
    DoEntFire("zombie_skin_"+player.entindex(), "Kill", "", 0, null, null);

    if (IsSurvivor(player) || survivors.len() == 0)
        return;

    if (player.GetTeam() != GetZombiesTeam())
    {
        player.SwitchTeam(GetZombiesTeam());
        player.ForceRespawn();
    }
	for (local i = 0; i < GLOBAL_WEAPON_COUNT; i++)
	{
		local weapon = GetPropEntityArray(player, "m_hMyWeapons", i)
        if (!IsZombieAllowed(weapon))
            weapon.Destroy();
        else if (weapon != null && weapon.GetSlot() == 2)
            SetPropEntity(player, "m_hActiveWeapon", weapon);
    }

    RunWithDelay("DressUpZombie(activator)", player, 1);
    //player.AddCondEx(Constants.ETFCond.TF_COND_INVULNERABLE, 3.5, null);
}
AddListener("spawn", TrySpawnAsZombie, 0);

function DressUpZombie(player)
{
    if (!IsZombie(player))
        return;
    SetPropInt(player, "m_iPlayerSkinOverride", 1);
    local playerClass = GetPropInt(player, "m_PlayerClass.m_iClass");
    AddWeapon(player, "tf_wearable", 5617, ZOMBIE_MODELS[playerClass], 0);
}

function Death_Zombie(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    DoEntFire("zombie_skin_"+player.entindex(), "Kill", "", 0, null, null);
}
AddListener("death", Death_Zombie, 0);

function NoCrumpkins(params)
{
    local ammoPack = null;
    while (ammoPack = Entities.FindByClassname(ammoPack, "tf_ammo_pack"))
        if (GetPropInt(ammoPack, "m_iWorldModelIndex") == crumpkin_model)
            ammoPack.Destroy();
    foreach (player in GetAllValidPlayers())
        player.RemoveCond(Constants.ETFCond.TF_COND_CRITBOOSTED_PUMPKIN);
}
AddListener("tick_frame", NoCrumpkins, 0);